/* -------------------------------- 

File#: _1_search-input
Title: Search input
Descr: Search input field with custom button
Usage: codyhouse.co/license

-------------------------------- */
:root {
    --search-input-btn-width: 2.2em;
    --search-input-icon-size: 1em;
    --search-input-shortcut-margin: 0.325em
        /* gap between the shortcut badge and the input edges */
}

.search-input {
    position: relative
}

.search-input__input {
    width: 100%;
    height: 100%
}

.search-input__input::-webkit-search-decoration,
.search-input__input::-webkit-search-cancel-button,
.search-input__input::-webkit-search-results-button,
.search-input__input::-webkit-search-results-decoration {
    -webkit-appearance: none
}

.search-input__input::-ms-clear,
.search-input__input::-ms-reveal {
    display: none;
    width: 0;
    height: 0
}

.search-input--icon-right .search-input__input {
    padding-right: var(--search-input-btn-width)
}

.search-input--icon-left .search-input__input {
    padding-left: var(--search-input-btn-width)
}

.search-input__btn {
    position: absolute;
    top: 0;
    right: 0;
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100%;
    width: var(--search-input-btn-width)
}

.search-input__btn:active .icon {
    transform: translateY(2px)
}

.search-input__btn .icon {
    display: block;
    --size: var(--search-input-icon-size);
    margin-left: auto;
    margin-right: auto;
    color: var(--color-contrast-low);
    /* icon color */
    transition: 0.2s
}

.search-input--icon-left .search-input__btn {
    left: 0;
    right: auto;
    pointer-events: none
}

.search-input__btn:focus .icon,
.search-input .search-input__input:focus+.search-input__btn .icon {
    color: var(--color-primary)
        /* active icon color */
}

/* --shortcut */
.search-input__shortcut {
    position: absolute;
    right: var(--search-input-shortcut-margin);
    top: var(--search-input-shortcut-margin);
    height: calc(100% - var(--search-input-shortcut-margin) * 2);
    display: flex;
    align-items: center;
    background-color: var(--color-bg);
    border: 1px solid var(--color-contrast-lower);
    border-radius: var(--radius-sm);
    --space-unit: 1em;
    padding: 0 var(--space-3xs);
    line-height: 1;
    color: var(--color-contrast-medium)
}

.search-input:focus-within .search-input__shortcut {
    display: none
}

/* -------------------------------- 

File#: _1_expandable-search
Title: Expandable Search
Descr: A search button that expands to reveal a search input element
Usage: codyhouse.co/license

-------------------------------- */
:root {
    --expandable-search-size-compact: 2.2em;
    /* height and width - compact version /  height - expanded version */
    --expandable-search-size-expanded: 10em;
    /* width - expanded version */
    --expandable-search-radius: 50em;
    /* border radius */
    --expandable-search-icon-size: 1.2em;
    /* lens icon size */
    --expandable-search-btn-padding: 2px
        /* gap between button and input element */
}

.expandable-search {
    position: relative;
    display: inline-block;
    -webkit-user-select: none;
    user-select: none
}

.expandable-search__input {
    width: var(--expandable-search-size-compact);
    height: var(--expandable-search-size-compact);
    color: transparent;
    overflow: hidden;
    border-radius: var(--expandable-search-radius);
    transition: width 0.3s var(--ease-out), box-shadow 0.3s, background-color 0.3s
}

.expandable-search__input::placeholder {
    opacity: 0;
    color: transparent
}

.expandable-search__input:hover {
    background-color: hsla(var(--color-contrast-higher-h), var(--color-contrast-higher-s), var(--color-contrast-higher-l), 0.1);
    cursor: pointer
}

.expandable-search__input:not(:focus):not(.expandable-search__input--has-content) {
    padding: 0px
        /* padding = 0 if search is not expanded */
}

.expandable-search__input:focus,
.expandable-search__input.expandable-search__input--has-content {
    background-color: var(--color-bg);
    width: var(--expandable-search-size-expanded);
    padding-top: 0;
    padding-right: calc(var(--expandable-search-btn-padding, 2px) + var(--expandable-search-size-compact));
    padding-left: var(--space-sm);
    padding-bottom: 0;
    outline: none;
    box-shadow: var(--shadow-md), 0 0 0 2px var(--color-primary);
    color: var(--color-contrast-higher);
    cursor: auto;
    -webkit-user-select: auto;
    user-select: auto
}

.expandable-search__input:focus::placeholder,
.expandable-search__input.expandable-search__input--has-content::placeholder {
    opacity: 1;
    color: var(--color-contrast-low)
}

.expandable-search__input:focus+.expandable-search__btn {
    pointer-events: auto
}

.expandable-search__input::-webkit-search-decoration,
.expandable-search__input::-webkit-search-cancel-button,
.expandable-search__input::-webkit-search-results-button,
.expandable-search__input::-webkit-search-results-decoration {
    display: none
}

.expandable-search__btn {
    position: absolute;
    display: flex;
    top: var(--expandable-search-btn-padding, 2px);
    right: var(--expandable-search-btn-padding, 2px);
    width: calc(var(--expandable-search-size-compact) - var(--expandable-search-btn-padding, 2px) * 2);
    height: calc(var(--expandable-search-size-compact) - var(--expandable-search-btn-padding, 2px) * 2);
    border-radius: var(--expandable-search-radius);
    z-index: 1;
    pointer-events: none;
    transition: background-color 0.3s
}

.expandable-search__btn .icon {
    display: block;
    margin: auto;
    height: var(--expandable-search-icon-size);
    width: var(--expandable-search-icon-size)
}

.expandable-search__btn:hover {
    background-color: hsla(var(--color-contrast-higher-h), var(--color-contrast-higher-s), var(--color-contrast-higher-l), 0.1)
}

.expandable-search__btn:focus {
    outline: none;
    background-color: hsla(var(--color-primary-h), var(--color-primary-s), var(--color-primary-l), 0.15)
}

/* -------------------------------- 

File#: _2_dropdown
Title: Dropdown
Descr: A hoverable link that toggles the visibility of a dropdown list
Usage: codyhouse.co/license

-------------------------------- */
:root {
    --dropdown-item-padding: var(--space-2xs) var(--space-sm)
}

.dropdown {
    position: relative
}

.dropdown__menu {
    width: 200px;
    border-radius: var(--radius-md);
    padding: var(--space-3xs) 0;
    background-color: var(--color-bg-light);
    box-shadow: var(--inner-glow), var(--shadow-sm);
    z-index: var(--z-index-popover, 5);
    position: absolute;
    left: 0;
    top: 100%;
    font-size: 1rem;
    opacity: 0;
    visibility: hidden;
    transition: opacity 0.2s, visibility 0s 0.2s
}

@media (pointer: fine) {

    .dropdown__wrapper:hover>.dropdown__menu,
    .dropdown__sub-wrapper:hover>.dropdown__menu {
        opacity: 1;
        visibility: visible;
        transition: opacity 0.2s
    }

    .dropdown__sub-wrapper:hover>.dropdown__menu {
        left: 100%
    }
}

@media not all and (pointer: fine) {
    .dropdown__trigger-icon {
        display: none
    }
}

.dropdown__item {
    display: block;
    text-decoration: none;
    color: var(--color-contrast-high);
    padding: var(--dropdown-item-padding);
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    transition: 0.2s
}

.dropdown__item:hover,
.dropdown__item.dropdown__item--hover {
    background-color: hsla(var(--color-contrast-higher-h), var(--color-contrast-higher-s), var(--color-contrast-higher-l), 0.075)
}

.dropdown__separator {
    height: 1px;
    background-color: var(--color-contrast-lower);
    margin: var(--dropdown-item-padding)
}

.dropdown__sub-wrapper {
    position: relative
}

.dropdown__sub-wrapper>.dropdown__item {
    position: relative;
    padding-right: calc(var(--space-sm) + 12px)
}

.dropdown__sub-wrapper>.dropdown__item .icon {
    position: absolute;
    display: block;
    width: 12px;
    height: 12px;
    right: var(--space-2xs);
    top: calc(50% - 6px)
}

.dropdown__sub-wrapper>.dropdown__menu {
    top: calc(var(--space-2xs) * -1);
    box-shadow: var(--inner-glow), var(--shadow-md)
}

.dropdown__menu {
    top: calc(100% + 4px)
}

.dropdown__sub-wrapper .dropdown__menu {
    top: calc(var(--space-2xs) * -1)
}

@media (pointer: fine) {
    .dropdown__menu--is-visible {
        opacity: 1;
        visibility: visible;
        transition: opacity 0.2s
    }
}

.dropdown__menu--hide {
    opacity: 0;
    visibility: hidden;
    transition: opacity 0.2s, visibility 0s 0.2s
}

.dropdown__sub-wrapper>.dropdown__menu--is-visible,
.dropdown__sub-wrapper>.dropdown__menu--hide {
    left: 100%
}

.dropdown__sub-wrapper>.dropdown__menu--is-visible.dropdown__menu--left,
.dropdown__sub-wrapper>.dropdown__menu--hide.dropdown__menu--left {
    left: -100%
}

/* -------------------------------- 

File#: _1_side-navigation
Title: Side Navigation
Descr: Vertical side navigation template
Usage: codyhouse.co/license

-------------------------------- */
:root {
    --sidenav-list-item-height: auto;
    --sidenav-list-item-padding-x: 16px;
    --sidenav-icon-size: 16px;
    --sidenav-icon-text-gap: 8px;
    --sidenav-sublist-control-size: 20px;
    --sidenav-sublist-control-icon-size: 12px;
    --sidenav-sublist-control-margin-right: 4px
}

.sidenav__list .sidenav__list {
    display: none
}

.sidenav__list .sidenav__list .sidenav__link {
    padding-left: calc(var(--sidenav-list-item-padding-x) + var(--sidenav-sublist-control-size) + var(--sidenav-sublist-control-margin-right) + var(--sidenav-icon-size) + var(--sidenav-icon-text-gap))
}

.sidenav__item {
    position: relative
}

.sidenav__item--expanded .sidenav__list {
    display: block
}

.sidenav__item--expanded .sidenav__sublist-control .icon {
    transform: rotate(90deg)
}

.sidenav__link {
    display: flex;
    height: var(--sidenav-list-item-height);
    align-items: center;
    padding: var(--space-xxs) var(--sidenav-list-item-padding-x) var(--space-xxs) calc(var(--sidenav-list-item-padding-x) + var(--sidenav-sublist-control-size) + var(--sidenav-sublist-control-margin-right));
    text-decoration: none;
    color: var(--color-contrast-high);
    transition: 0.2s
}

.sidenav__link:hover {
    background-color: hsla(var(--color-contrast-higher-h), var(--color-contrast-higher-s), var(--color-contrast-higher-l), 0.05)
}

.sidenav__link[aria-current=page],
.sidenav__link--current {
    background-color: hsla(var(--color-primary-h), var(--color-primary-s), var(--color-primary-l), 0.1);
    color: var(--color-primary)
}

.sidenav__icon {
    width: var(--sidenav-icon-size);
    height: var(--sidenav-icon-size);
    margin-right: var(--sidenav-icon-text-gap)
}

.sidenav__text {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    padding-right: var(--space-2xs)
}

.sidenav__counter {
    display: inline-block;
    background-color: hsla(var(--color-contrast-higher-h), var(--color-contrast-higher-s), var(--color-contrast-higher-l), 0.15);
    color: var(--color-contrast-high);
    font-size: var(--text-xs);
    padding: var(--space-4xs) var(--space-3xs);
    border-radius: 50em;
    margin-left: auto
}

.sidenav__sublist-control {
    display: block;
    width: var(--sidenav-sublist-control-size);
    height: var(--sidenav-sublist-control-size);
    border-radius: 50%;
    position: absolute;
    left: var(--sidenav-list-item-padding-x);
    top: calc((var(--sidenav-list-item-height) - var(--sidenav-sublist-control-size)) / 2);
    transition: 0.2s
}

.sidenav__sublist-control .icon {
    display: block;
    width: var(--sidenav-sublist-control-icon-size);
    height: var(--sidenav-sublist-control-icon-size);
    margin: auto;
    transition: transform 0.2s
}

.sidenav__sublist-control:hover {
    background-color: hsla(var(--color-contrast-higher-h), var(--color-contrast-higher-s), var(--color-contrast-higher-l), 0.15)
}

.sidenav__label {
    padding-left: var(--sidenav-list-item-padding-x)
}

.sidenav__divider {
    width: 100%;
    height: 1px;
    background-color: var(--color-contrast-lower)
}

.sidenav--basic .sidenav__link,
.sidenav--basic .sidenav__label {
    padding-left: var(--sidenav-list-item-padding-x)
}

.sidenav--minified {
    --sidenav-list-item-height: auto
}

.sidenav--minified .sidenav__list .sidenav__list {
    display: none !important
}

.sidenav--minified .sidenav__link,
.sidenav--minified .sidenav__label {
    padding-left: var(--sidenav-list-item-padding-x)
}

.sidenav--minified .sidenav__link {
    flex-direction: column;
    padding-top: var(--space-sm);
    padding-bottom: var(--space-sm)
}

.sidenav--minified .sidenav__icon {
    margin: 0 0 var(--sidenav-icon-text-gap)
}

.sidenav--minified .sidenav__text {
    padding: 0
}

.sidenav--minified .sidenav__counter,
.sidenav--minified .sidenav__sublist-control {
    display: none
}

/* -------------------------------- 

File#: _3_dashboard-navigation
Title: Dashboard Navigation
Descr: Dashboard navigation template
Usage: codyhouse.co/license

-------------------------------- */
:root {
    --app-ui-header-height: 50px;
    --app-ui-static-sidebar-width: 360px
}

.app-ui .sidenav {
    --sidenav-list-item-padding-x: var(--space-md)
}

.app-ui__header {
    position: sticky;
    top: 0;
    display: flex;
    align-items: center;
    background-color: var(--color-bg);
    justify-content: space-between;
    height: var(--app-ui-header-height);
    z-index: 1
}

.app-ui__logo-wrapper {
    position: relative;
    height: 100%;
    display: flex;
    align-items: center
}

.app-ui__logo {
    display: block;
    width: 104px;
    height: 30px
}

.app-ui__logo svg {
    display: block;
    width: inherit;
    height: inherit
}

.app-ui__menu-btn {
    display: flex;
    justify-content: center;
    align-items: center;
    width: 40px;
    height: 40px;
    font-size: 24px;
    color: var(--color-contrast-high);
    cursor: pointer;
    transition: 0.2s
}

.app-ui__menu-btn .icon {
    display: block
}

.app-ui__menu-btn .icon__group {
    stroke-width: 2px
}

.app-ui__menu-btn .icon__group>* {
    stroke-dasharray: 24;
    transition: transform 0.3s var(--ease-in-out), stroke-dashoffset 0.3s, opacity 0.3s
}

.app-ui__menu-btn .icon__group>*:nth-child(1) {
    transform-origin: 12px 6px
}

.app-ui__menu-btn .icon__group>*:nth-child(2) {
    stroke-dashoffset: 0
}

.app-ui__menu-btn .icon__group>*:nth-child(3) {
    transform-origin: 12px 18px
}

.app-ui__nav {
    position: fixed;
    top: var(--app-ui-header-height);
    left: 0;
    width: 100%;
    height: calc(100% - var(--app-ui-header-height));
    overflow: auto;
    -webkit-overflow-scrolling: touch;
    flex-direction: column;
    background-color: var(--color-bg);
    z-index: 1;
    display: none
}

.app-ui__body {
    position: relative;
    min-height: calc(100vh - var(--app-ui-header-height));
    z-index: 1;
    background-color: var(--color-bg-dark)
}

.app-ui__header-btn,
.app-ui__user-btn {
    position: relative;
    width: 36px;
    height: 36px;
    border-radius: 50%;
    text-decoration: none
}

.app-ui__header-btn {
    display: flex;
    transition: background-color 0.3s;
    color: var(--color-contrast-high)
}

.app-ui__header-btn .icon {
    font-size: 20px;
    display: block;
    margin: auto
}

.app-ui__header-btn:hover {
    cursor: pointer;
    background-color: hsla(var(--color-contrast-higher-h), var(--color-contrast-higher-s), var(--color-contrast-higher-l), 0.1)
}

.app-ui__notification-indicator {
    position: absolute;
    top: 2px;
    right: 2px;
    width: 8px;
    height: 8px;
    background-color: var(--color-accent);
    box-shadow: 0 1px 3px hsla(var(--color-accent-h), var(--color-accent-s), var(--color-accent-l), 0.4);
    border-radius: 50%
}

.app-ui__user-btn {
    display: block;
    overflow: hidden;
    transition: 0.3s
}

.app-ui__user-btn img {
    display: block;
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    -o-object-fit: cover;
    object-fit: cover
}

.app-ui__user-btn:hover {
    opacity: 0.85
}

.app-ui--nav-expanded .app-ui__nav {
    display: flex
}

.app-ui--nav-expanded .app-ui__nav>* {
    animation: app-ui-nav-animation 0.5s var(--ease-out)
}

.app-ui--nav-expanded .app-ui__menu-btn .icon__group>*:nth-child(1) {
    transform: translateY(6px) rotate(-45deg)
}

.app-ui--nav-expanded .app-ui__menu-btn .icon__group>*:nth-child(2) {
    stroke-dashoffset: 24
}

.app-ui--nav-expanded .app-ui__menu-btn .icon__group>*:nth-child(3) {
    transform: translateY(-6px) rotate(45deg)
}

@media (min-width: 64rem) {
    .app-ui .sidenav {
        --sidenav-list-item-padding-x: var(--space-sm)
    }

    .app-ui .expandable-search {
        --expandable-search-size-compact: 36px;
        --expandable-search-size-expanded: 220px;
        --expandable-search-icon-size: 20px
    }

    .app-ui__nav {
        display: flex;
        width: var(--app-ui-static-sidebar-width);
        box-shadow: var(--shadow-xs)
    }

    .app-ui__logo-wrapper {
        width: var(--app-ui-static-sidebar-width)
    }

    .app-ui__logo-wrapper::after {
        content: "";
        position: absolute;
        right: 0;
        top: 15%;
        height: 70%;
        width: 1px;
        background-color: var(--color-contrast-lower)
    }

    .app-ui__body {
        min-height: 0;
        position: fixed;
        height: calc(100% - var(--app-ui-header-height));
        left: var(--app-ui-static-sidebar-width);
        width: calc(100% - var(--app-ui-static-sidebar-width));
        overflow: auto;
        -webkit-overflow-scrolling: touch
    }
}

@keyframes app-ui-nav-animation {
    from {
        opacity: 0;
        transform: translateY(-10px)
    }

    to {
        opacity: 1;
        transform: translateY(0px)
    }
}